unit Unit1;

{
  15-puzzle game control: buttons, events
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, dav7RotationBtn, dav7components, ImgList,
  Buttons, shellapi;

type
  TForm1 = class(TForm)
    msglabel: TLabel;
    levelrotationBtn: TDav7RotationBtn;
    levellabel: TStaticText;
    Label2: TLabel;
    playBtn: TDavArrayBtn;
    newBtn: TDavArrayBtn;
    Label1: TLabel;
    depthrotationBtn: TDav7RotationBtn;
    depthlabel: TStaticText;
    searchModeBtn: TDavArrayBtn;
    Label3: TLabel;
    Label4: TLabel;
    Image1: TImage;
    solveBtn: TDavArrayBtn;
    fileBtn: TDavArrayBtn;
    Label6: TLabel;
    SaveDialog1: TSaveDialog;
    Label7: TLabel;
    Label8: TLabel;
    menuBtn: TDavArrayBtn;
    moveLabel: TStaticText;
    MovecountLabel: TStaticText;
    Label9: TLabel;
    Label10: TLabel;
    maskBtn: TDavArrayBtn;
    Label5: TLabel;
    GImage: TImage;
    dav7Timer1: Tdav7Timer;
    OpenDialog1: TOpenDialog;
    FoLabel: TLabel;
    BaLabel: TLabel;
    ZeLabel: TLabel;
    toplabel: TLabel;
    stopImage: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure levelrotationBtnChange(sender: TObject; position: Byte);
    procedure playBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure newBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure newBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure playBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure depthrotationBtnChange(sender: TObject; position: Byte);
    procedure maskBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure maskBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure searchModeBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure solveBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure solveBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure fileBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure fileBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure menuBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure menuBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure GImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FoLabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FoLabelMouseEnter(Sender: TObject);
    procedure FoLabelMouseLeave(Sender: TObject);
    procedure FoLabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure stopImageClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure setMoveInfo(m,c : byte);
procedure setFormCaption;
function getSearchDepth : byte;
function getSearchLevel : byte;

var
  Form1: TForm1;
  busy : boolean;//set if tile is moving, computer is searching
  stopFlag : boolean;

implementation

{$R *.dfm}

uses game_unit,io_unit,paint_unit;

const formheader = '15-puzzle: ';

type TmainButton = (mbFile,mbNew,mbPlay,mbSolve,mbHelp,mbOff);

var field1,field2 : byte;
    field1OK : boolean;
    totaltime : double;
    mainbutton : Tmainbutton = mbOff;
    CF : boolean;

function getSearchDepth : byte;
begin
 result := form1.depthrotationBtn.position + 1;
end;

function getSearchLevel : byte;
begin
 result := (form1.levelRotationBtn.position + 1)*10;
end;

procedure setformcaption;
//extract file name to show in caption of form
var s : string;
begin
 s := gamefilename;
 if length(s) > 0 then
  begin
   s := extractfilename(s);
   if pos(fileprefix,s) > 0 then delete(s,1,length(fileprefix));
  end;
 form1.Caption := formheader+s;
end;

procedure setmoveInfo(m,c : byte);
begin
 moveNr := m;
 movecount := c;
 with form1 do
  begin
   movelabel.Caption := inttostr(moveNr);
   movecountlabel.Caption := inttostr(movecount);
  end;
end;

procedure exchangefields;
//exchange field1,2 of Game[0,..]
var h,n : byte;
begin
 if field1 = field2 then
  begin
   field2 := Game[moveNr,0];
   n := abs(field2-field1);
   if (n <> 1) and (n <> 4) then exit;
  end;
 h := Game[0,field1];
 Game[0,field1] := Game[0,field2];
 Game[0,field2] := h;
 if Game[0,0] = field1 then Game[0,0] := field2
  else if Game[0,0] = field2 then Game[0,0] := field1;
 paintTile(0,field1,0,0);
 paintTile(0,field2,0,0);
end;

//----------------------

function GetSearchMode : TSearchMode;
begin
 with form1.searchModeBtn do
  if getBtnStatus(byte(smBreadthfirst))=stDown then result := smBreadthfirst
   else result := smDepthfirst;
end;

procedure playermove(f1 : byte);
var m1,n,zf : byte;
    s : string;
begin
 if movecount = maxmove then
  begin
   form1.msglabel.caption := 'move buffer is full';
   exit;
  end;
//
 zf := Game[moveNr,0];//zero field
 n := abs(zf-f1);
 if (n <> 1) and (n <> 4) then exit;
//
 m1 := moveNr + 1;
 for n := 1 to 16 do Game[m1,n] := Game[moveNr,n];
 setMoveInfo(moveNr+1,moveNr+1);  //update moveNr , movecount
 game[moveNr,zf] := game[moveNr,f1];
 game[moveNr,f1] := 0;
 game[moveNr,0] := f1;
 slowmove(moveNr-1,moveNr);
 s := 'move '+inttostr(movecount);
 if testsolution then
  begin
   s := s + ' game solved';
  end;
 form1.msglabel.Caption := s;
end;

procedure searchreset;
begin
 totaltime := 0;
 form1.msglabel.Caption := 'click -partial- to start search';
 setMoveInfo(0,0);
 paintgame(0);
end;

procedure solvePartial;
var searchstate : Tsearch;
    searchresult : Tsearchresult;
    searchtime : double;
    s,ss : string;
begin
 setMoveInfo(movecount,movecount);
 stopflag := false;
 ss := 'searching.';
 form1.msglabel.Caption := ss;
 application.ProcessMessages;
 searchstate := ssStart;
 searchmode := getSearchMode;
 busy := true;
 form1.dav7timer1.start;
 repeat
  case searchmode of
   smDepthfirst   : searchresult := DFsearch(searchstate);
   smBreadthfirst : searchresult := BFsearch(searchstate);
   else searchresult := srEnd;
  end;//case
  case searchresult of
   srSolution : with form1 do
                 begin
                  dav7timer1.stop;
                  searchtime := form1.dav7timer1.Elapsedtime;
                  totaltime := totaltime + searchtime;
                  if updateGame then
                   begin
                    setMoveInfo(moveNr,moveNr);
                    s := 'Puzzle solved. ';
                    s := s + 'Moves = '+inttostr(movecount)+'. ';
                    s := s + 'Time = '+formatfloat('##0.###',searchtime/1000)+'. ';
                    s := s + 'TotalTime = '+formatfloat('##0.###',totaltime/1000);
                    s := s + ' msecs.';
                    paintgame(moveNr);
                   end
                    else s := 'solution too long';
                   msglabel.Caption := s;
                 end;
   srTimeout  : begin
                 ss := ss + '.';
                 if length(ss) = 30 then ss := 'searching.';
                 form1.msglabel.Caption := ss;
                 application.ProcessMessages;
                 if stopflag then
                  begin
                   form1.msglabel.Caption := 'search aborted';
                   searchresult := srEnd;
                   form1.dav7Timer1.stop;
                  end
                   else searchstate := ssContinue;
                end;
   srEnd      : begin
                 form1.dav7Timer1.stop;
                 s := 'no solution. ';
                 searchtime := form1.dav7timer1.Elapsedtime;
                 s := s + 'Time = '+formatfloat('##0.###',searchtime/1000);
                 s := s + ' msecs.';
                 form1.msglabel.caption := s;
                end;
  end;//case
 until searchresult <> srTimeOut;
 busy := false;
end;

procedure initreplay;
begin
 setMoveInfo(0,movecount);
 paintgame(0);
end;

procedure reduceproc;
var dm,i,mc : byte;
    di : smallInt;
    mrange : byte;
    ss : Tsearch;
begin
 stopFlag := false;
 mrange := form1.depthRotationBtn.position + 1;
 if movecount <= mrange then
  begin
   form1.msglabel.Caption := 'OK';
   exit;
  end;
//
 busy := true;
 i := movecount-mrange;
 while i > 0 do
  begin
   ss := ssStart;
   form1.msglabel.Caption := 'reducing...'+ inttostr(i);
   application.ProcessMessages;
   setReduceRange(i,mrange);
   while RBFsearch(ss,mc) = srTimeOut do
    begin
     ss := ssContinue;
     application.ProcessMessages;
     if stopflag then begin
                       form1.msglabel.Caption := 'reduction ended';
                       busy := false;
                       exit;
                      end;
    end;
//
   if mc < mrange then
    begin
     Greduce(i,i+mrange,mc);
     dm := mrange - mc;
     setmoveInfo(0,movecount);
     di := i - dm;
     if di <= 0 then i := 0
      else i := di;
    end
    else dec(i);
  end;//while
//
 setMoveInfo(0,movecount);
 paintgame(moveNr);
 form1.msglabel.Caption := 'reduction finished. movecount = '+inttostr(movecount);
 busy := false;
end;

function xy2field(var f : byte; x,y : smallInt) : boolean;
//return true & field f if on field
var column,row : smallInt;
begin
 result := (x > 0) and (x < 400) and (y > 0) and (y < 400);
 if result then
  begin
   column := (x div 100);
   row := (y div 100);
   f := (row shl 2) + column + 1;
  end;
end;

procedure  startmoving(mcode : byte);
//mcode 1: forward;  2:backward
//cf : continue flag
begin
 repeat
   case mcode of
     1 : if moveNr < moveCount then
          begin
           slowmove(moveNr,moveNr + 1);
           setmoveInfo(moveNr+1,movecount);
          end else CF := false;
     2 : if moveNr > 0 then
          begin
           slowmove(moveNr,moveNr-1);
           setMoveInfo(moveNr-1,movecount);
          end else CF := false;
    end;//case
 until CF = false;
end;

function checkmasks : boolean;
//return true if at least 1 mask set
var i : byte;
begin
 i := 0;
 repeat
  inc(i);
  result := Gmask[i];
 until result or (i=16);
end;

//-- create , destroy --

procedure TForm1.FormCreate(Sender: TObject);
begin
 searchModeBtn.BtnDown(0);
 setmasks(true);
 initgame;
 msglabel.Caption := 'Welcome at the 15-puzzle explorer. Open or enter a new game.';
 clearGImage;
 setformcaption;
end;

//-- mouse events --

procedure TForm1.GImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var fld1 : byte;
begin
 if busy then exit;
//
 field1OK := false;
 if xy2field(fld1,x,y) then
  case mainbutton of
   mbSolve : begin
              GMask[fld1] := not Gmask[fld1];
              paintTile(moveNr,fld1,0,0);
             end;
   mbNew   : begin
              field1 := fld1;
              field1OK := true;
             end;
   mbPlay : playermove(fld1);
  end
   else field1 := $ff;
end;

procedure TForm1.GImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if busy then exit;
//
 if field1OK then
  if xy2field(field2,x,y) then
   begin
    field1OK := false;
    exchangefields;
   end;
end;

//-- button changes --

procedure TForm1.menuBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 if busy then
  if status = stDown then
   begin
    menuBtn.BtnRelease(btnNr);
    if mainbutton <> mbOff then menuBtn.BtnDown(byte(mainbutton));
    exit;
   end;
//
 msglabel.Caption := '';
 case mainbutton of  //closing actions
  mbFile   : begin
              fileBtn.enabled := false;
             end ;
  mbNew    : begin
              newBtn.Enabled := false;
             end;
  mbPlay   : begin
              playBtn.Enabled := false;
             end;
  mbSolve  : begin
              solveBtn.Enabled := false;
             end;
  mbHelp   : ;
  mbOff    : ;
 end;
 mainbutton := TMainbutton(btnNr);
 if status = stDown then //opening actions
  case mainbutton of
   mbFile   : begin
               fileBtn.Enabled := true;
              end;
   mbNew    : begin
               newBtn.Enabled := true;
               msglabel.caption := 'select new puzzle';
              end;
   mbPlay   : begin
               setmasks(false);
               paintgame(moveNr);
               playBtn.enabled := true;
               if cansolve = false then msglabel.Caption := 'no solution possible'
                else msglabel.caption := 'Click on tile to move';
              end;
   mbSolve  : begin
               solveBtn.Enabled := true;
               if cansolve = false then msglabel.caption := 'no solution possible';
              end;
   mbHelp   : begin
               ShellExecute(0,'open','http://www.davdata.nl/math/puzzle15help.html', nil, nil, SW_SHOWNORMAL);
               menuBtn.BtnRelease(BtnNr);
               mainbutton := mbOff;
              end;
   mbOff    : ;
  end;
end;

procedure TForm1.fileBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 if status = stDown then
  case BtnNr of
   0 : OpenGame;
   1 : SaveGame;
   2 : SaveGameAs;
  end;
 fileBtn.BtnRelease(btnNr);
 menuBtn.BtnRelease(0);
 mainbutton := mbOff;
 fileBtn.enabled := false;
end;

procedure TForm1.maskBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 if status = stDown then
  if busy = false then
   begin
    case btnNr of
     0 : setmasks(false);
     1 : setmasks(true);
    end;
    paintgame(moveNr);
   end; 
  maskBtn.BtnRelease(btnNr);
end;

procedure TForm1.newBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
const extreme : array[0..16] of byte = (16,15,14,8,12,10,11,9,13,2,6,5,1,3,4,7,0);
var i : byte;
   sd : byte;
begin
 setMoveInfo(0,0);
 if status = stDown then
  begin
   case btnNr of
    0 : begin
         initgame;
         msglabel.Caption := 'game set to solved state';
        end;
    1 : begin
         for i := 0 to 16 do Game[0,i] := extreme[i];
         msglabel.Caption := 'game set to extreme state';
        end;
    2 : begin
         sd := getSearchLevel;
         randomgame(sd);
         msglabel.Caption := 'game set to search depth of '+inttostr(sd);
        end;
   end;
   newBtn.BtnRelease(btnNr);
   paintgame(0);
  end;
end;

procedure TForm1.playBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
var i : byte;
begin
 if status = stDown then
  if busy = false then
   begin
    msglabel.Caption := '';
    case BtnNr of
     0 : begin                    //store
          for i := 0 to 16 do Game[0,i] := Game[moveNr,i];
          setMoveInfo(0,0);
          msglabel.Caption := 'game set as original';
         end;
     1 : begin
          setMoveInfo(0,0);
          paintgame(0);
         end;
     2 : if moveNr > 0 then
          begin
           slowmove(moveNr,moveNr-1);
           setMoveInfo(moveNr-1,moveNr-1);
         end;
    end;//case
   end;
  playBtn.BtnRelease(btnNr);
end;

procedure TForm1.solveBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 if status = stDown then
  if busy = false then
   case BtnNr of
    0 : searchreset;
    1 : if checkmasks then solvepartial
         else msglabel.Caption := 'no tiles selected';
    2 : reduceproc;
   end;
 SolveBtn.BtnRelease(btnNr);
end;

procedure TForm1.depthrotationBtnChange(sender: TObject; position: Byte);
var sdepth : byte;
begin
 sdepth := position+1;
 depthlabel.Caption := inttostr(sdepth);
end;

procedure TForm1.levelrotationBtnChange(sender: TObject; position: Byte);
var lv : byte;
begin
 lv := position + 1;
 levellabel.Caption := inttostr(lv*10);
end;

//-- component paint events --

procedure TForm1.FormPaint(Sender: TObject);
var x1,y1,x2,y2 : word;
begin
 paintedges(GImage,$606060,5);
 paintedges(FoLabel,0,1);
 paintedges(BaLabel,0,1);
 paintedges(ZeLabel,0,1);
 paintedges(TopLabel,0,1);
 paintedges(stopImage,0,1);
 with canvas do
  begin
   pen.Color := $808080;
   pen.Width := 3;
   x1 := newBtn.Left + (newBtn.Width shr 1) + newBtn.Border;
   y1 := newBtn.Top + newBtn.Height;
   y2 := GImage.Top - 30;
   moveto(x1,y1);
   lineto(x1,y2);
   x2 := levelrotationBtn.left + (levelRotationBtn.width shr 1);
   lineto(x2,y2);
   lineto(x2,levelrotationBtn.Top);
   x1 := solveBtn.Left + (solveBtn.Width shr 1) + solveBtn.Border;
   x2 := depthrotationBtn.left + (depthRotationBtn.width shr 1);
   y1 := solveBtn.Top + solveBtn.Height;
   y2 := y1 + 20;
   moveto(x1,y1);
   lineto(x1,y2);
   lineto(x2,y2);
   lineto(x2,depthrotationBtn.Top);
  end;
end;

procedure TForm1.fileBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const fileBtnText : array[0..2]of string =
      ('open','save','save as');
var r : Trect;
    w : word;
begin
 with fileBtn do with canvas do
  begin
   font.Name := 'arial';
   font.Height := 18;
   brush.Style := bsClear;
   if status <> stFlat then font.Style := [fsBold] else font.Style := [];
   r := getBtnRect(btnNr);
   w := textwidth(fileBtnText[btnNr]);
   textout(r.Left + (btnWidth - w) shr 1,r.Top + 5,fileBtnText[btnNr]);
  end;
end;

procedure TForm1.newBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const newBtnText : array[0..2] of string = ('solved','extreme','random');
var r : Trect;
    w : word;
begin
 with newBtn do with canvas do
  begin
   font.Name := 'arial';
   font.Height := 18;
   brush.Style := bsClear;
   if status <> stFlat then font.Style := [fsBold] else font.Style := [];
   r := getBtnRect(btnNr);
   w := textwidth(newBtnText[btnNr]);
   textout(r.Left + (btnWidth - w) shr 1,r.Top + 5,newBtnText[btnNr]);
  end;
end;

procedure TForm1.maskBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const maskBtnText : array[0..1] of string = ('clear','set all');
var r : Trect;
    w : word;
begin
 with maskBtn do with canvas do
  begin
   font.Name := 'arial';
   font.Height := 18;
   brush.Style := bsClear;
   if status <> stFlat then font.Style := [fsBold] else font.Style := [];
   r := getBtnRect(btnNr);
   w := textwidth(maskBtnText[btnNr]);
   textout(r.Left + (btnWidth - w) shr 1,r.Top + 5,maskBtnText[btnNr]);
  end;
end;

procedure TForm1.playBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const playBtnText : array[0..2] of string = ('store','original','back');
var r : Trect;
    w : word;
begin
 with playBtn do with canvas do
  begin
   font.Name := 'arial';
   font.Height := 18;
   brush.Style := bsClear;
   if status <> stFlat then font.Style := [fsBold] else font.Style := [];
   r := getBtnRect(btnNr);
   w := textwidth(playBtnText[btnNr]);
   textout(r.Left + (btnWidth - w) shr 1,r.Top + 5,playBtnText[btnNr]);
  end;
end;

procedure TForm1.solveBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const solveBtnText : array[0..2] of string = ('original','partial','reduce');
var r : Trect;
    w : word;
begin
 with solveBtn do with canvas do
  begin
   font.Name := 'arial';
   font.Height := 18;
   brush.Style := bsClear;
   if status <> stFlat then font.Style := [fsBold] else font.Style := [];
   r := getBtnRect(btnNr);
   w := textwidth(solveBtnText[btnNr]);
   textout(r.Left + (btnWidth - w) shr 1,r.Top + 5,solveBtnText[btnNr]);
  end;
end;

procedure TForm1.searchModeBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const BtnText : array[0..1] of string = ('breadth','depth');
var r : Trect;
    w : word;
begin
 with searchModeBtn do with canvas do
  begin
   font.Name := 'arial';
   font.Height := 18;
   brush.Style := bsClear;
   if status <> stFlat then font.Style := [fsBold] else font.Style := [];
   r := getBtnRect(btnNr);
   w := textwidth(BtnText[btnNr]);
   textout(r.Left + (btnWidth - w) shr 1,r.Top + 5,BtnText[btnNr]);
  end;
end;

procedure TForm1.menuBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const BtnText : array[0..4] of string =
      ('file','set game','play','solve','help');
var r : Trect;
    w : word;
begin
 with menuBtn do with canvas do
  begin
   font.Name := 'arial';
   font.Height := 18;
   font.color := $000000;
   brush.Style := bsClear;
   if status <> stFlat then font.Style := [fsBold] else font.Style := [];
   r := getBtnRect(btnNr);
   w := textwidth(BtnText[btnNr]);
   textout(r.Left + (btnWidth - w) shr 1,r.Top + 5,BtnText[btnNr]);
  end;
end;

procedure TForm1.FoLabelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if busy then begin
               CF := false;
               exit;
              end;
//
 with TLabel(sender) do
  begin
   color := $ffffff;
   case tag of
    1,
    2 : begin
         cf := button = mbRight; //continuous flag
         startmoving(tag);
        end;
    3 : begin
         setMoveInfo(0,movecount);
         paintGame(0);
        end;
    4 : begin
         setMoveInfo(movecount,movecount);
         paintGame(moveNr);
        end; 
   end;
  end;
end;

procedure TForm1.FoLabelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 with TLabel(sender) do
  begin
   color := $00f0f0;
  end;
end;

procedure TForm1.FoLabelMouseEnter(Sender: TObject);
begin
 TLabel(sender).color := $00f0f0;
end;

procedure TForm1.FoLabelMouseLeave(Sender: TObject);
begin
 TLabel(sender).color := clBtnFace;
end;

procedure TForm1.stopImageClick(Sender: TObject);
begin
 stopFlag := true;//abort search, reduce ops.
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
 ShellExecute(0,'open','http://www.davdata.nl', nil, nil, SW_SHOWNORMAL);
end;

end.
