unit paint_unit;

{
 paint procedures for 15-puzzle
}

interface

uses windows,classes,sysUtils,forms,graphics,controls;

const XTabs : array[1..3] of byte = (30,50,80); //move table tabs
      maxLinecount = 25;

procedure paintTile(m,pos : byte; dx,dy : shortInt);
procedure paintgame(m : byte);
procedure paintMoveArrow(pos,dir : byte);
procedure slowmove(g1,g2 : byte);
procedure delay(msec : dword);
procedure clearGImage;
procedure paintedges(ct : Tcontrol; col : dword; w : byte);

implementation

uses unit1,game_unit;

procedure delay(msec : dword);
//use dav7timer1 on form1
begin
 msec := msec * 1000;
 with form1.dav7Timer1 do
  begin
   start;
   repeat
    application.ProcessMessages;
    stop;
   until Elapsedtime >= msec///microseconds returned
  end;
end;

function getFieldrect(fld : byte) : Trect;
//game field rectangle
var col,row : byte;
begin
 col := (fld-1) and $3;
 row := (fld-1) shr 2;
 with result do
  begin
   left := col*100;
   top := row*100;
   right := left+100;
   bottom := top+100;
  end;
end;

procedure clearGImage;
begin
 with form1.GImage do with canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   font.Name := 'arial';
   font.Height := 28;
   font.style := [];
  end;
 paintgame(moveNr);
end;

procedure paintMoveArrow(pos,dir : byte);
//arrow painting on elements
const X : array[0..3,0..6] of shortInt =
          ((-30,-30, 10, 10, 30, 10, 10),
           ( 10, 10, 20,  0,-20,-10,-10),
           ( 30,-10,-10,-30,-10,-10, 30),
           (-10,-10,-20,  0, 20, 10, 10));
      Y : array[0..3,0..6] of shortInt =
          ((-10, 10, 10,20, 0,-20,-10),
           ( 30,-10,-10,-30,-10,-10, 30),
           (-10,-10,-20 , 0, 20, 10, 10),
           (-30, 10, 10, 30, 10, 10,-30));
var cx,cy : smallInt;
    i : byte;
begin
 cx := 100*((pos-1) and $3) + 50;
 cy := 100*((pos-1) shr 2) + 50;
 with form1.GImage.Canvas do
  begin
   pen.Width := 2;
   pen.Color := $0;
   pen.Style := psSolid;
   moveto(cx+X[dir,0],cy+Y[dir,0]);
   for i := 1 to 6 do lineto(cx+X[dir,i],cy+Y[dir,i]);
   lineto(cx+X[dir,0],cy+Y[dir,0]);
  end;
end;

procedure paintgame(m : byte);
var i : byte;
begin
 for i := 1 to 16 do paintTile(m,i,0,0);
end;

procedure paintTile(m,pos : byte; dx,dy : shortInt);
//paint tile in paintbox1
var r : Trect;
    x,y,x1,y1,x2,y2 : smallInt;
    colr : dword;
    i,nr : byte;
    s : string;
begin
 r := getfieldrect(pos);
 x1 := r.left + dx;
 y1 := r.top + dy;
 x2 := x1 + 100;
 y2 := y1 + 100;
 nr := Game[m,pos];
//
 if nr = 0 then colr := $ffffff
  else
   if ((nr-1) and $1) xor (((nr-1) shr 2) and $1) = 1 then colr := $80ffff
    else colr := $80ff80;
 with form1.GImage.canvas do
  begin
   brush.style := bsSolid;
   brush.color := colr;
   fillrect(rect(x1+5,y1+5,x2-5,y2-5));
   pen.color := $c0c0c0;
   moveto(x2-5,y1+4);
   lineto(x1+4,y1+4);
   lineto(x1+4,y2-5);
   pen.color := $000000;
   lineto(x2-5,y2-5);
   lineto(x2-5,y1+4);
   if Gmask[pos] then pen.color := $ff0000
    else pen.color := $ffffff;
   for i := 1 to 3 do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i-1);
     lineto(x2-i-1,y2-i-1);
     lineto(x2-i-1,y1+i);
     lineto(x1+i,y1+i);
    end;
   if nr = 0 then s := ''
    else s := inttostr(nr);
   brush.Style := bsClear;
   x := x1 + ((100 - textwidth(s)) shr 1);
   y := y1 + ((100 - textheight(s)) shr 1);
   textout(x,y,s);
  end;
end;

procedure slowmove(g1,g2 : byte);
var x,y,dx,dy : smallint;
    r : Trect;
    dir,i,zf1,zf2 : byte;
begin
 busy := true;
 zf1 := Game[g1,0];
 zf2 := Game[g2,0];
 dir := $ff;
 case zf1 - zf2 of
  1 : dir := 0;
 -1 : dir := 2;
  4 : dir := 3;
 -4 : dir := 1;
 end;
 r := getFieldRect(zf2);
 case dir of
  0 : begin
       dx := 1;
       dy := 0;
      end;
  1 : begin
       dy := -1;
       dx := 0;
      end;
  2 : begin
       dx := -1;
       dy := 0;
      end;
  3 : begin
       dx := 0;
       dy := 1;
      end;
  else begin
        dx := 0; dy := 0;
       end;
 end;
 x := 0;
 y := 0;
 for i := 1 to 100 do
  begin
   inc(x,dx);
   inc(y,dy);
   paintTile(g1,zf2,x,y);
   case dir of
    0 : r.Right := r.left + x + 1;
    1 : r.Top := r.Bottom + y - 1;
    2 : r.Left := r.Right + x - 1;
    3 : r.Bottom := r.Top + y + 1;
   end;
   with form1.GImage.Canvas do
    begin
     brush.Style := bsSolid;
     brush.Color := $ffffff;
     fillrect(r);
    end;
   delay(7);
  end;
 painttile(g2,zf2,0,0);
 busy := false;
end;

procedure paintedges(ct : Tcontrol; col : dword; w : byte);
//paint edges of w wide color col around ct
var x1,y1,x2,y2 : word;
    pc : Tcomponent;
    i : byte;
begin
 if w = 0 then exit else dec(w);
 with ct do
  begin
   x1 := left - w -1 ;
   y1 := top - w - 1;
   x2 := left + width + w;
   y2 := top + height + w;
  end;
 pc := ct.GetParentcomponent;
 with Tform(pc).canvas do
  begin
   pen.width := 1;
   pen.style := psSolid;
   pen.color := col;
   for i := 0 to w do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(x1+i,y1+i);
    end;
  end;
end;

end.
